/*
 +=================================================================================================================================+
 | Project : 8 Channel MAX455 Video Switcher                                                                                       |
 | Author  : Mike G7GTN - South Devon                                                                                              | 
 | Version : 1.03                                                                                                                  |
 | IDE     : Compiled in Ardunio Version 1.0.5                                                                                     |  
 | Date    : September 2016                                                                                                        |
 +=================================================================================================================================+
                                                                                                                                                                                                    
 VVVVVVVV           VVVVVVVV  IIIIIIIIII  DDDDDDDDDDDDD        EEEEEEEEEEEEEEEEEEEEEE       OOOOOOOOO     
 V::::::V           V::::::V  I::::::::I  D::::::::::::DDD     E::::::::::::::::::::E     OO:::::::::OO   
 V::::::V           V::::::V  I::::::::I  D:::::::::::::::DD   E::::::::::::::::::::E   OO:::::::::::::OO 
 V::::::V           V::::::V  II::::::II  DDD:::::DDDDD:::::D  EE::::::EEEEEEEEE::::E  O:::::::OOO:::::::O
  V:::::V           V:::::V     I::::I      D:::::D    D:::::D   E:::::E       EEEEEE  O::::::O   O::::::O
   V:::::V         V:::::V      I::::I      D:::::D     D:::::D  E:::::E               O:::::O     O:::::O
    V:::::V       V:::::V       I::::I      D:::::D     D:::::D  E::::::EEEEEEEEEE     O:::::O     O:::::O
     V:::::V     V:::::V        I::::I      D:::::D     D:::::D  E:::::::::::::::E     O:::::O     O:::::O
      V:::::V   V:::::V         I::::I      D:::::D     D:::::D  E:::::::::::::::E     O:::::O     O:::::O
       V:::::V V:::::V          I::::I      D:::::D     D:::::D  E::::::EEEEEEEEEE     O:::::O     O:::::O
        V:::::V:::::V           I::::I      D:::::D     D:::::D  E:::::E               O:::::O     O:::::O
         V:::::::::V            I::::I      D:::::D    D:::::D   E:::::E       EEEEEE  O::::::O   O::::::O
          V:::::::V           II::::::II  DDD:::::DDDDD:::::D  EE::::::EEEEEEEE:::::E  O:::::::OOO:::::::O
           V:::::V            I::::::::I  D:::::::::::::::DD   E::::::::::::::::::::E   OO:::::::::::::OO 
            V:::V             I::::::::I  D::::::::::::DDD     E::::::::::::::::::::E     OO:::::::::OO   
             VVV              IIIIIIIIII  DDDDDDDDDDDDD        EEEEEEEEEEEEEEEEEEEEEE       OOOOOOOOO     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
    SSSSSSSSSSSSSSS   WWWWWWWW                           WWWWWWWW  IIIIIIIIII  TTTTTTTTTTTTTTTTTTTTTTT         CCCCCCCCCCCCC  HHHHHHHHH     HHHHHHHHH
  SS:::::::::::::::S  W::::::W                           W::::::W  I::::::::I  T:::::::::::::::::::::T      CCC::::::::::::C  H:::::::H     H:::::::H
 S:::::SSSSSS::::::S  W::::::W                           W::::::W  I::::::::I  T:::::::::::::::::::::T    CC:::::::::::::::C  H:::::::H     H:::::::H
 S:::::S     SSSSSSS  W::::::W                           W::::::W  II::::::II  T:::::TT:::::::TT:::::T   C:::::CCCCCCCC::::C  HH::::::H     H::::::HH
 S:::::S               W:::::W           WWWWW           W:::::W     I::::I    TTTTTT  T:::::T  TTTTTT  C:::::C       CCCCCC    H:::::H     H:::::H  
 S:::::S                W:::::W         W:::::W         W:::::W      I::::I            T:::::T         C:::::C                  H:::::H     H:::::H  
  S::::SSSS              W:::::W       W:::::::W       W:::::W       I::::I            T:::::T         C:::::C                  H::::::HHHHH::::::H  
   SS::::::SSSSS          W:::::W     W:::::::::W     W:::::W        I::::I            T:::::T         C:::::C                  H:::::::::::::::::H  
     SSS::::::::SS         W:::::W   W:::::W:::::W   W:::::W         I::::I            T:::::T         C:::::C                  H:::::::::::::::::H  
        SSSSSS::::S         W:::::W W:::::W W:::::W W:::::W          I::::I            T:::::T         C:::::C                  H::::::HHHHH::::::H  
             S:::::S         W:::::W:::::W   W:::::W:::::W           I::::I            T:::::T         C:::::C                  H:::::H     H:::::H  
             S:::::S          W:::::::::W     W:::::::::W            I::::I            T:::::T          C:::::C       CCCCCC    H:::::H     H:::::H  
 SSSSSSS     S:::::S           W:::::::W       W:::::::W           II::::::II        TT:::::::TT         C:::::CCCCCCCC::::C  HH::::::H     H::::::HH
 S::::::SSSSSS:::::S            W:::::W         W:::::W            I::::::::I        T:::::::::T          CC:::::::::::::::C  H:::::::H     H:::::::H
 S:::::::::::::::SS              W:::W           W:::W             I::::::::I        T:::::::::T            CCC::::::::::::C  H:::::::H     H:::::::H
  SSSSSSSSSSSSSSS                 WWW             WWW              IIIIIIIIII        TTTTTTTTTTT               CCCCCCCCCCCCC  HHHHHHHHH     HHHHHHHHH
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
 Hardware :
 
            Ardunio NANO module
            MAXIM MAX455 8 Channel Video Multiplexer
            LCD 16X2 (HD44780) + I2C Backpack Module
            TSOP IR Sensor 38KHz centre frequency
            
 I/O Pin Usage:
                                              Ardunio NANO Pinouts
                                         
            TSOP2838 38KHz IR Remote Sensor   - Digital Pin D11
            CW Tone Output                    - PWM Digital Pin 6
            16X2 LCD With I2C LCD Backpack    - SDA Analog Pin A4
            16X2 LCD With I2C LCD Backpack    - SCL Analog Pin A5
            MAX455 Multiplexer A0             - Digital Pin D2
            MAX455 Multiplexer A1             - Digital Pin D3	
	    MAX455 Multiplexer A2             - Digital Pin D4
            PWR LED Optional                  - Digital Pin D7

            All other I/O pins are spare

 Features : 
 
	    Sony IR Remote control
            16X2 LCD Via I2C Backpack (defaults to 0X27 hex with no solder links)
            Serial Scan 115200 baud for I2C LCD hexadecimal bus address
            CW Tone on decoded IR channel selection		
	    Backlight On/Off Setting is Saved to Eeprom

 Remote:    Tested with generic Sony IR control (remote code page number 0140 used) on a generic universal remote handset

 IR Buttons:  PWR = Show firmware version 
              1 = Source One      3 = Source Three
              2 = Source Two      4 = Source Four
              5 = Source Five     6 = Source Six
              7 = Source Seven    8 = Source Eight
              Ch Up = Backlight On  Ch down = Backlight Off

Libraries:
              To successfully compile the project you will have to install the included IRremote (from the zip file) and Morse library in to your 
              working Ardunio libraries subdirectory. Remember to restart the Ardunio IDE if you already had this open before installing.

CW Library:

              The CW library is written by Erik Linder SM0RVV and Mark VandeWettering K6HX
              http://www.w5obm.us/Arduino/Arduino%20for%20Ham%20Radio%20Book/Customized%20Libraries/Morse/
           
  +========================================================================================================================================+
              
*/

#define software 1.03

// Setup Digital I/O Pins for Maxim MAX455 Multiplexer
#define MAX455A0 2
#define MAX455A1 3
#define MAX455A2 4 

// PWR LED
#define PWRLED 7

// For Serial Messages
#define SERIALOUT

// CW Tones
#define SENDCW						// Comment out for no CW audio tones on IR decode			

// Scan for I2C devices & send to serial terminal
#define I2CSCAN

// Eeprom Addresses
#define BACKLIGHT_ADDRESS 4  				// EEPROM address for LCD Backlight Control
#include <EEPROM.h>	        	    		// Read & Write to ATMEGA328P Eeprom space

// Include CW Library
#include <Morse.h>
Morse morse(6, 18, 1);                                  // PWM Pin,Speed, On

// include I2C LCD library
#include <Wire.h>
#include <LCD.h>
#include <LiquidCrystal_I2C.h>
#define I2C_ADDR 0x27   				// I2C LCD Hexadecimal Address Of PCF8574A Device
#define BACKLIGHT_PIN     3
#define En_pin  2
#define Rw_pin  1
#define Rs_pin  0
#define D4_pin  4
#define D5_pin  5
#define D6_pin  6
#define D7_pin  7

int n = 1;

LiquidCrystal_I2C lcd(I2C_ADDR,En_pin,Rw_pin,Rs_pin,D4_pin,D5_pin,D6_pin,D7_pin);

// IR Remote
#include <IRremote.h>                           	// IR Decoding Library
int RECV_PIN = 11;      		          	// IR detector to Digital Pin 11
IRrecv irrecv(RECV_PIN);
decode_results results;


int x = 0;
// 8 arrays that form LCD custom number segments
byte LT[8] = 
{
  B00111,
  B01111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111
};

byte UB[8] =
{
  B11111,
  B11111,
  B11111,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000
};

byte RT[8] =
{
  B11100,
  B11110,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111
};

byte LL[8] =
{
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B01111,
  B00111
};

byte LB[8] =
{
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B11111,
  B11111,
  B11111
};

byte LR[8] =
{
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11110,
  B11100
};

byte UMB[8] =
{
  B11111,
  B11111,
  B11111,
  B00000,
  B00000,
  B00000,
  B11111,
  B11111
};

byte LMB[8] =
{
  B11111,
  B00000,
  B00000,
  B00000,
  B00000,
  B11111,
  B11111,
  B11111
};

//--------------------------------------------------------------------------------------- 
// GENERAL HARDWARE SETUP
//--------------------------------------------------------------------------------------- 
void setup()
{			
  setiopindirection();                          	 // Set MAX455 I/O
  pinMode(PWRLED, OUTPUT);                               // Show powered via optional LED
  digitalWrite(PWRLED, HIGH); 
  Serial.begin(115200);
  Serial.flush();

  #if defined I2CSCAN                           	// Check for I2C addresses connected to Analog pins A4 & A5
      i2cscan();                                	// Scan bus & send via Serial Terminal @115200
  #endif  

  Wire.begin( );
  lcd.begin (16,2); 					// LCD 16x2

  irrecv.enableIRIn();           			// Start IR receiver

  lcd.createChar(8,LT);                         	// HD44780 LCD Custom Character assignments
  lcd.createChar(1,UB);
  lcd.createChar(2,RT);
  lcd.createChar(3,LL);
  lcd.createChar(4,LB);
  lcd.createChar(5,LR);
  lcd.createChar(6,UMB);
  lcd.createChar(7,LMB);  
  lcd.setBacklightPin(BACKLIGHT_PIN,POSITIVE);		// Switch on the backlight
  lcd.setBacklight(HIGH);
  lcd.home();                                   	// Line 1, position 1
  checkeeprom(EEPROM.read(BACKLIGHT_ADDRESS));		// Check for user saved Backlight control
  title();						// Project title
}

//--------------------------------------------------------------------------------------- 
// BUILD LARGE CUSTOM LCD NUMBERS & OTHER REQUIRED SYMBOLS
//--------------------------------------------------------------------------------------- 
void n0()
{ 
  lcd.clear(); 
  lcd.setCursor(x, 0); 
  lcd.write(8);  
  lcd.write(1); 
  lcd.write(2);
  lcd.setCursor(x, 1); 
  lcd.write(3);  
  lcd.write(4);  
  lcd.write(5);
}

void n1()
{
  
  lcd.setCursor(x,0);
  lcd.write(1);
  lcd.write(2);
  lcd.setCursor(x+1,1);
  lcd.write(255);
}

void n2()
{
  lcd.setCursor(x,0);
  lcd.write(6);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(3);
  lcd.write(7);
  lcd.write(7);
}

void n3()
{
  lcd.setCursor(x,0);
  lcd.write(6);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(7);
  lcd.write(7);
  lcd.write(5); 
}

void n4()
{
  lcd.setCursor(x,0);
  lcd.write(3);
  lcd.write(4);
  lcd.write(2);
  lcd.setCursor(x+2, 1);
  lcd.write(255);
}

void n5()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(6);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(7);
  lcd.write(7);
  lcd.write(5);
}

void n6()
{
  lcd.setCursor(x,0);
  lcd.write(8);
  lcd.write(6);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(3);
  lcd.write(7);
  lcd.write(5);
}

void n7()
{
  lcd.setCursor(x,0);
  lcd.write(1);
  lcd.write(1);
  lcd.write(2);
  lcd.setCursor(x+1, 1);
  lcd.write(8);
}

void n8()
{  
  lcd.setCursor(x,0);
  lcd.write(8);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(3);
  lcd.write(7);
  lcd.write(5);
}



void customsm()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.setCursor(x, 1);
  lcd.write(7);
}
  
//--------------------------------------------------------------------------------------- 
// TITLE
//--------------------------------------------------------------------------------------- 
void title()
{
   #if defined SERIALOUT                          	
      Serial.println ("Video Switcher");                                	
   #endif
   lcd.print("Video Switcher");
   lcd.setCursor (6,1);        				// LCD 2nd line  
   lcd.print(software);    
   delay(2200);                                 	// Delay to read MSG
   lcd.clear();
   lcd.setCursor (1,0); 
   lcd.print("de Mike G7GTN");
   lcd.setCursor (2,1);        				// Move to 2nd line  
   lcd.print("For CQ-DATV");  
   delay(2100); 
   lcd.clear();
   cmdready();						// Waiting for IR command msg
}

//--------------------------------------------------------------------------------------- 
// Waiting for IR Remote Command 
//--------------------------------------------------------------------------------------- 
void cmdready()
{
   lcd.home (); 
   lcd.print("IR Remote Ready");
   lcd.setCursor(0,1);
   lcd.print("    ");
}

//--------------------------------------------------------------------------------------- 
//                           Switch Video Channels
// Logic switching table from MAX455 multiplexer datasheet page 6
// http://www.alldatasheet.com/datasheet-pdf/pdf/73400/MAXIM/MAX455.html
//
//  ---------------|------|------|-------
//  Video Channel  |  A0  |  A1  |  A2
//  ---------------|------|------|-------
//           1     |  L   |  L   |  L
//           2     |  H   |  L   |  L
//           3     |  L   |  H   |  L
//           4     |  H   |  H   |  L
//           5     |  L   |  L   |  H
//           6     |  H   |  L   |  H
//           7     |  L   |  H   |  H
//           8     |  H   |  H   |  H
//
//--------------------------------------------------------------------------------------- 
void chan1()
{
 digitalWrite(MAX455A0, LOW);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, LOW);
 digitalWrite(MAX455A2, LOW);
 lcd.clear();                                           // Clear spurious junk
 n1();							// Display large LCD Numeric Digit
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH1");                                	
 #endif
}

void chan2()
{
 digitalWrite(MAX455A0, HIGH);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, LOW);
 digitalWrite(MAX455A2, LOW);
 lcd.clear();
 n2();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH2");                                	
 #endif
}

void chan3()
{
 digitalWrite(MAX455A0, LOW);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, HIGH);
 digitalWrite(MAX455A2, LOW);
 lcd.clear();
 n3();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH3");                                	
 #endif
}

void chan4()
{
 digitalWrite(MAX455A0, HIGH);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, HIGH);
 digitalWrite(MAX455A2, LOW); 
 lcd.clear(); 
 n4();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH4");                                	
 #endif
}

void chan5()
{
 digitalWrite(MAX455A0, LOW);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, LOW);
 digitalWrite(MAX455A2, HIGH);
 lcd.clear(); 
 n5();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH5");                                	
 #endif
}

void chan6()
{
 digitalWrite(MAX455A0, HIGH);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, LOW);
 digitalWrite(MAX455A2, HIGH);
 lcd.clear(); 
 n6();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH6");                                	
 #endif 
}

void chan7()
{
 digitalWrite(MAX455A0, LOW);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, HIGH);
 digitalWrite(MAX455A2, HIGH);
 lcd.clear(); 
 n7();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH7");                                	
 #endif 
}

void chan8()
{
 digitalWrite(MAX455A0, HIGH);                   	// Logic levels on Multiplexer  
 digitalWrite(MAX455A1, HIGH);
 digitalWrite(MAX455A2, HIGH);
 lcd.clear();
 n8();
 selected();
 #if defined SERIALOUT                          	
      Serial.println ("CH8");                                	
 #endif 
}

//--------------------------------------------------------------------------------------- 
// LCD SELECTED MESSAGE
//--------------------------------------------------------------------------------------- 
void selected()
{
  lcd.setCursor(6,0);
  lcd.print("Channel    ");
  lcd.setCursor (6,1);                        		// Second LCD Line
  lcd.print("Selected"); 
}  

//--------------------------------------------------------------------------------------- 
// CHECK EEPROM FOR LCD BACKLIGHT SETTING
//--------------------------------------------------------------------------------------- 
void checkeeprom(uint8_t level)
{
  // If EEPROM is unwritten (0xFF)
  if (level==255)
     backlighton();      
  switch(level)
  {
    case 1:           
      backlighton();     
      break;
    case 2:
      backlightoff();     
      break;
  }
  
  if ((level>=1)&&(level<=3))
    EEPROM.write(BACKLIGHT_ADDRESS, level);
}

//--------------------------------------------------------------------------------------- 
// Take action based on IR code received
// Hex codes are from the decoded Sony Remote Buttons
// This used Sony Remote Code 0140
//--------------------------------------------------------------------------------------- 
void translateIR()  
{ 
  switch(results.value)
  {
    case 0x10:  					// IR 1 Button
      chan1();                                          // Switch video channel 
       #if defined SENDCW 						 
           morse.sendmsg("1");      
       #endif
      break;          
    case 0x810: 					// IR 2 Button 
      chan2();
       #if defined SENDCW 						 
           morse.sendmsg("2");      
       #endif
      break;
    case 0x410: 					// IR 3 Button
      chan3();
       #if defined SENDCW 						 
           morse.sendmsg("3");      
       #endif
      break;
    case 0xC10:			        		// IR 4 Button
      chan4();
       #if defined SENDCW 						 
           morse.sendmsg("4");      
       #endif
      break;
    case 0x210:  					// IR 5 Button
      chan5();
       #if defined SENDCW 						 
           morse.sendmsg("5");      
       #endif
      break;
    case 0xA10: 					// IR 6 Button
      chan6();
       #if defined SENDCW 						 
           morse.sendmsg("6");      
       #endif 
      break;
    case 0x610: 					// IR 7 Button
      chan7();
       #if defined SENDCW 						 
           morse.sendmsg("7");      
       #endif
      break;
    case 0xE10: 					// IR 8 Button
      chan8();
       #if defined SENDCW 						 
           morse.sendmsg("8");      
       #endif
      break;
    case 0x110:                         		// IR 9 Button
      break;
    case 0xA90:                         		// IR Power Button
      version(); 
      break;
    case 0x090:	                      	        	// IR Channel Up   
      backlighton();                            	// Turn on Backlight & save value
       #if defined SENDCW 						 
           morse.sendmsg("ON");      
       #endif
      break; 
    case 0x890:                                 	// IR Channel Down   
      backlightoff();      	                        // Turn off Backlight & save value
       #if defined SENDCW 						 
           morse.sendmsg("OFF");      
       #endif
      break;    
  } 
}

//--------------------------------------------------------------------------------------- 
// LCD BACKLIGHT SET ON
// BACKLIGHT VALUE IS SAVED TO EEPROM
//--------------------------------------------------------------------------------------- 
void backlighton()
{
  lcd.setBacklight(HIGH);      				// Backlight on 
  // Save value to Eeprom
  int value;
  value=1;
  EEPROM.write(BACKLIGHT_ADDRESS, value); 
}

//--------------------------------------------------------------------------------------- 
// LCD BACKLIGHT SET OFF
// BACKLIGHT VALUE IS SAVED TO EEPROM
//--------------------------------------------------------------------------------------- 
void backlightoff()
{
  lcd.setBacklight(LOW);      				// Backlight off	
  // Save value to Eeprom
  int value;
  value=2;
  EEPROM.write(BACKLIGHT_ADDRESS, value);
}

//--------------------------------------------------------------------------------------- 
// CODE VERSION  
//--------------------------------------------------------------------------------------- 
void version()
{  
  #if defined SERIALOUT                          	
      Serial.println (software);                                	
  #endif
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Video Switcher");
    lcd.setCursor (0,1);        			// 2nd line  
    lcd.print(software);
    morse.sendmsg("V103");    
    delay(1600);                              
    cmdready();   
}  

//--------------------------------------------------------------------------------------- 
// LARGE LCD FONT
//--------------------------------------------------------------------------------------- 
void show(int number) 
{
  switch(number) 
  {
    case 1:
      n1();
      break;
    case 2:
      n2();
      break;
    case 3:
      n3();
      break;
    case 4:
      n4();
      break;
    case 5:
      n5();
      break;
    case 6:
      n6();
      break;
    case 7:
      n7();
      break;
    case 8:
      n8();
      break;
  }
}

//--------------------------------------------------------------------------------------- 
// MAX455 MULTIPLEXER I/O SETUP
//--------------------------------------------------------------------------------------- 
void setiopindirection()
{
  pinMode(MAX455A0, OUTPUT);                    	// Set MAX455 Multiplexer A0-A2 Control pin direction
  pinMode(MAX455A1, OUTPUT);      
  pinMode(MAX455A2, OUTPUT);       
}

//--------------------------------------------------------------------------------------- 
// Scan for I2C connected bus devices
// To use uncomment the #define I2CSCAN on line 138
//
// This code will scan all devices that are connected to Analog Pins A4 (SDA) & A5 (SCL) 
// and report via a serial terminal @115200 baud
// on the bus address in both decimal and hexadecimal. 
//--------------------------------------------------------------------------------------- 
void i2cscan()
{
 Serial.println ("[I2C Bus Scanner]");
  byte count = 0;
  Wire.begin();
  for (byte i = 1; i < 127; i++)                	// I2C address range
  {
    Wire.beginTransmission (i);
    if (Wire.endTransmission () == 0)
      {
      Serial.print ("Found device at address: ");
      Serial.print ("Decimal ");
      Serial.print (i, DEC);
      Serial.print (" Hexadecimal(0x");
      Serial.print (i, HEX);
      Serial.println (")");
      count++;
      delay (1);  
      } 
  } 
  Serial.print ("Found ");
  Serial.print (count, DEC);
  Serial.println (" device(s).");
  Serial.println ("[Finished I2C Scan]");  
}


//--------------------------------------------------------------------------------------- 
// MAIN CONTROL LOOP
//--------------------------------------------------------------------------------------- 
void loop()
{ 
  if (irrecv.decode(&results))  			// Sony IR signal received 
  {
    translateIR();
    for (int z=0; z<2; z++)     			// skip the 2nd and 3rd signal repeats
    {
      irrecv.resume();          			// receive next value
    }
  }
}
